/*
 * Copyright (c) 2017 Adrian Siekierka
 *
 * This file is part of Unlimited Chisel Works.
 *
 * Unlimited Chisel Works is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Unlimited Chisel Works is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Unlimited Chisel Works.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.ucw;

import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommandSender;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nullable;
import java.util.*;

public class CommandUCWDebug extends CommandBase {
	@Override
	public String func_71517_b() {
		return "ucw_debug";
	}

	@Override
	public String func_71518_a(ICommandSender sender) {
		return "no, don't";
	}

	@Override
	public List<String> func_184883_a(MinecraftServer server, ICommandSender sender, String[] args, @Nullable BlockPos targetPos) {
		if (args.length == 1) {
			Set<String> domains = new HashSet<>();
			for (UCWBlockRule rule : UnlimitedChiselWorks.BLOCK_RULES) {
				domains.add(rule.fromBlock.getRegistryName().func_110624_b());
			}

			return func_71530_a(args, domains.toArray(new String[domains.size()]));
		} else {
			return Collections.emptyList();
		}
	}

	@Override
	public void func_184881_a(MinecraftServer server, ICommandSender sender, String[] args) throws CommandException {
		if (sender instanceof EntityPlayerMP) {
			World world = sender.func_130014_f_();
			BlockPos pos = sender.func_180425_c();
			for (UCWBlockRule rule : UnlimitedChiselWorks.BLOCK_RULES) {
				if (args.length >= 1 && !rule.fromBlock.getRegistryName().toString().toLowerCase().startsWith(args[0].toLowerCase())) {
					continue;
				}

				for (UCWObjectFactory factory : rule.objectFactories.valueCollection()) {
					NonNullList<ItemStack> stackList = NonNullList.func_191196_a();
					factory.item.func_150895_a(CreativeTabs.field_78027_g, stackList);

					world.func_175656_a(pos, factory.base);
					BlockPos posCopy = pos.func_177972_a(EnumFacing.EAST);

					for (ItemStack stack : stackList) {
						try {
							world.func_175656_a(posCopy, factory.block.func_176203_a(stack.func_77960_j()));
							posCopy = posCopy.func_177972_a(EnumFacing.EAST);
						} catch (Exception e) {

						}
					}

					pos = pos.func_177968_d();
				}
			}
		}
	}
}
