/*
 * Copyright (c) 2017 Adrian Siekierka
 *
 * This file is part of Unlimited Chisel Works.
 *
 * Unlimited Chisel Works is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Unlimited Chisel Works is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Unlimited Chisel Works.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.ucw;

import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.NonNullList;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nullable;
import java.util.List;

public class ItemUCWProxy extends ItemBlock {
	private UCWBlockRule rule;
	private IBlockState base;

	public ItemUCWProxy(Block block) {
		super(block);
		rule = UCWObjectBroker.get().getRule();
		base = UCWObjectBroker.get().getBase();
		func_77627_a(true);
	}

	@Override
	@SideOnly(Side.CLIENT)
	public void func_77624_a(ItemStack stack, @Nullable World worldIn, List<String> tooltip, ITooltipFlag flagIn) {
		getItemThrough().func_77624_a(
				UCWUtils.copyChangeItem(stack, getItemThrough()),
				worldIn, tooltip, flagIn
		);
	}

	@Override
	public String func_77658_a() {
		return getItemFrom().func_77658_a();
	}

	@Override
	public String func_77667_c(ItemStack stack) {
		try {
			ItemStack proxyStack = new ItemStack(base.func_177230_c().func_180660_a(base, UnlimitedChiselWorks.RAND, 0), 1, base.func_177230_c().func_180651_a(base));
			if (stack.func_77942_o()) {
				proxyStack.func_77982_d(stack.func_77978_p());
			}
			return getItemFrom().func_77667_c(proxyStack);
		} catch (Exception e) {
			e.printStackTrace();
			return func_77658_a();
		}
	}
	@Override
	public String func_77653_i(ItemStack stack) {
		try {
			ItemStack proxyStack = new ItemStack(base.func_177230_c().func_180660_a(base, UnlimitedChiselWorks.RAND, 0), 1, base.func_177230_c().func_180651_a(base));
			if (stack.func_77942_o()) {
				proxyStack.func_77982_d(stack.func_77978_p());
			}
			return getItemFrom().func_77653_i(proxyStack);
		} catch (Exception e) {
			e.printStackTrace();
			return this.func_77667_c(stack);
		}
	}

	protected Item getItemFrom() {
		return Item.func_150898_a(rule.fromBlock);
	}

	protected Item getItemThrough() {
		return Item.func_150898_a(rule.throughBlock);
	}

	@Override
	public int func_77647_b(int damage) {
		if (rule.through.get(damage) != null) {
			return damage;
		} else {
			return 0;
		}
	}

	@Override
	public void func_150895_a(CreativeTabs tab, NonNullList<ItemStack> items) {
		Item origItem = getItemThrough();
		if (UnlimitedChiselWorks.useChiselGetSubItemsWorkaround && "chisel".equals(origItem.getRegistryName().func_110624_b())) {
			for (int i = 0; i < 16; i++) {
				if (rule.through.get(i) != null) {
					// FIXME: Dirt#9 doesn't really work well :-(
					if (rule.throughBlock.getRegistryName().toString().equals("chisel:dirt") && i == 9) {
						continue;
					}

					try {
						if (!rule.through.contains(rule.throughBlock.func_176203_a(i))) {
							continue;
						}
					} catch (Exception e) {

					}

					items.add(new ItemStack(this, 1, i));
				}
			}
		} else {
			NonNullList<ItemStack> proxyList = NonNullList.func_191196_a();
			origItem.func_150895_a(tab, proxyList);
			for (ItemStack stack : proxyList) {
				if (stack.func_77973_b() == origItem) {
					// FIXME: Dirt#9 doesn't really work well :-(
					if (rule.throughBlock.getRegistryName().toString().equals("chisel:dirt") && stack.func_77952_i() == 9) {
						continue;
					}

					try {
						if (!rule.through.contains(rule.throughBlock.func_176203_a(stack.func_77952_i()))) {
							continue;
						}
					} catch (Exception e) {

					}

					items.add(UCWUtils.copyChangeItem(stack, this));
				}
			}
		}
	}
}
